---
title: CanvasRenderingContext2D.filter
slug: Web/API/CanvasRenderingContext2D/filter
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Experimental
  - Property
---
<div>{{APIRef}} {{SeeCompatTable}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.filter</code></strong> property of the Canvas 2D API provides filter effects such as blurring and grayscaling. It is similar to the CSS {{cssxref("filter")}} property and accepts the same values.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>ctx</em>.filter = "<em>&lt;filter-function1&gt;</em> [<em>&lt;filter-function2&gt;</em>] [<em>&lt;filter-functionN&gt;</em>]";
<em>ctx</em>.filter = "none";
</pre>

<h3 id="Values">Values</h3>

<p>The <code>filter</code> property accepts a value of <code>"none"</code> or one or more of the following filter functions in a {{domxref("DOMString")}}.</p>

<dl>
 <dt><code><a href="/en-US/docs/Web/CSS/filter#url()">url()</a></code></dt>
 <dd>A CSS {{cssxref("&lt;url&gt;")}}. Takes an IRI pointing to an SVG filter element, which may be embedded in an external XML file.</dd>
 <dt><code><a href="/en-US/docs/Web/CSS/filter#blur()">blur()</a></code></dt>
 <dd>A CSS {{cssxref("&lt;length&gt;")}}. Applies a Gaussian blur to the drawing. It defines the value of the standard deviation to the Gaussian function, i.e., how many pixels on the screen blend into each other; thus, a larger value will create more blur. A value of <code>0</code> leaves the input unchanged.</dd>
 <dt><code><a href="/en-US/docs/Web/CSS/filter#brightness()">brightness()</a></code></dt>
 <dd>A CSS {{cssxref("&lt;percentage&gt;")}}. Applies a linear multiplier to the drawing, making it appear brighter or darker. A value under <code>100%</code> darkens the image, while a value over <code>100%</code> brightens it. A value of <code>0%</code> will create an image that is completely black, while a value of <code>100%</code> leaves the input unchanged.</dd>
 <dt><code><a href="/en-US/docs/Web/CSS/filter#contrast()">contrast()</a></code></dt>
 <dd>A CSS {{cssxref("&lt;percentage&gt;")}}. Adjusts the contrast of the drawing. A value of <code>0%</code> will create a drawing that is completely black. A value of <code>100%</code> leaves the drawing unchanged.</dd>
 <dt><code><a href="/en-US/docs/Web/CSS/filter#drop-shadow()">drop-shadow()</a></code></dt>
 <dd>Applies a drop shadow effect to the drawing. A drop shadow is effectively a blurred, offset version of the drawing's alpha mask drawn in a particular color, composited below the drawing. This function takes up to five arguments:
 <ul>
  <li><code>&lt;offset-x&gt;</code>: See {{cssxref("&lt;length&gt;")}} for possible units. Specifies the horizontal distance of the shadow.</li>
  <li><code>&lt;offset-y&gt;</code>: See {{cssxref("&lt;length&gt;")}} for possible units. Specifies the vertical distance of the shadow.</li>
  <li><code>&lt;blur-radius&gt;</code>: The larger this value, the bigger the blur, so the shadow becomes bigger and lighter. Negative values are not allowed.</li>
  <li><code>&lt;color&gt;</code>: See {{cssxref("&lt;color&gt;")}} values for possible keywords and notations.</li>
 </ul>
 </dd>
 <dt><code><a href="/en-US/docs/Web/CSS/filter#grayscale()">grayscale()</a></code></dt>
 <dd>A CSS {{cssxref("&lt;percentage&gt;")}}. Converts the drawing to grayscale. A value of <code>100%</code> is completely grayscale. A value of <code>0%</code> leaves the drawing unchanged.</dd>
 <dt><code><a href="/en-US/docs/Web/CSS/filter#hue-rotate()">hue-rotate()</a></code></dt>
 <dd>A CSS {{cssxref("&lt;angle&gt;")}}. Applies a hue rotation on the drawing. A value of <code>0deg</code> leaves the input unchanged.</dd>
 <dt><code><a href="/en-US/docs/Web/CSS/filter#invert()">invert()</a></code></dt>
 <dd>A CSS {{cssxref("&lt;percentage&gt;")}}. Inverts the drawing. A value of <code>100%</code> means complete inversion. A value of <code>0%</code> leaves the drawing unchanged.</dd>
 <dt><code><a href="/en-US/docs/Web/CSS/filter#opacity()">opacity()</a></code></dt>
 <dd>A CSS {{cssxref("&lt;percentage&gt;")}}. Applies transparency to the drawing. A value of <code>0%</code> means completely transparent. A value of <code>100%</code> leaves the drawing unchanged.</dd>
 <dt><code><a href="/en-US/docs/Web/CSS/filter#saturate()">saturate()</a></code></dt>
 <dd>A CSS {{cssxref("&lt;percentage&gt;")}}. Saturates the drawing. A value of <code>0%</code> means completely un-saturated. A value of <code>100%</code> leaves the drawing unchanged.</dd>
 <dt><code><a href="/en-US/docs/Web/CSS/filter#sepia()">sepia()</a></code></dt>
 <dd>A CSS {{cssxref("&lt;percentage&gt;")}}. Converts the drawing to sepia. A value of <code>100%</code> means completely sepia. A value of <code>0%</code> leaves the drawing unchanged.</dd>
 <dt><code>none</code></dt>
 <dd>No filter is applied. Initial value.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>To view these examples, make sure to use a browser that supports this feature; see the compatibility table below.</p>

<h3 id="Applying_a_blur">Applying a blur</h3>

<p>This example blurs a piece of text using the <code>filter</code> property.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js;highlight[4] notranslate">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

ctx.filter = 'blur(4px)';
ctx.font = '48px serif';
ctx.fillText('Hello world', 50, 100);
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Applying_a_blur', 700, 180) }}</p>

<h3 id="Applying_multiple_filters">Applying multiple filters</h3>

<p>You can combine as many filters as you like. This example applies the <code>contrast</code>, <code>sepia</code>, and <code>drop-shadow</code> filters to a photo of a rhino.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html notranslate">&lt;canvas id="canvas" width="400" height="150"&gt;&lt;/canvas&gt;
&lt;div style="display:none;"&gt;
  &lt;img id="source"
       src="https://mdn.mozillademos.org/files/5397/rhino.jpg"&gt;
&lt;/div&gt;</pre>

<h4 id="JavaScript_2">JavaScript</h4>

<pre class="brush: js notranslate">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');
const image = document.getElementById('source');

image.addEventListener('load', e =&gt; {
  // Draw unfiltered image
  ctx.drawImage(image, 0, 0, image.width * .6, image.height * .6);

  // Draw image with filter
  ctx.filter = 'contrast(1.4) sepia(1) drop-shadow(-9px 9px 3px #e81)';
  ctx.drawImage(image, 400, 0, -image.width * .6, image.height * .6);
});</pre>

<h4 id="Result_2">Result</h4>

<p>{{ EmbedLiveSample('Applying_multiple_filters', 700, 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#filters", "CanvasRenderingContext2D.filter")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.filter")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this property: {{domxref("CanvasRenderingContext2D")}}</li>
 <li>CSS {{cssxref("filter")}}</li>
 <li>CSS {{cssxref("&lt;filter-function&gt;")}}</li>
</ul>
